#ifndef __LC_User_ToTest
#define __LC_User_ToTest

#ifndef ENABLE_LCB
#define ENABLE_LCB
#endif
#include <cppbind.h>
#include <lc_database.h>
#include <lc_dlist.h>
#include <lc_d_ref.h>

#include "lc_persistent_t.h"
#include <callin.h>

ISC_NSP_BEGIN

class LC_Persistent_t;
class LC_User_ToTest;

class LC_User_ToTest : public LC_Persistent_t {
   friend class lc_d_ref<LC_User_ToTest>;

protected:
   LC_User_ToTest() : LC_Persistent_t() {}

   LC_User_ToTest(Database* db, int oref, const wchar_t* cl_name) : LC_Persistent_t(db, oref, cl_name) {}

private:
   static wchar_t __srv_cl_name[12];
   static int __class_num;
   static int __get_class_num();
bool in_get() { return (get_db() && ((LC_Database *)get_db())->in_get()); }

   void set_id(const wchar_t *val)
   {
      id(val);
   }

   void set_id(const char *val)
   {
      id(val);
   }

public:
   virtual ~LC_User_ToTest()
   {
      if (get_db() && lock_type() > LC_LOCK_NONE)
      {
         THREAD_CHECK(get_db(),"~LC_User_ToTest()");
         unlock();
      }
      delete_oref();
   }

   void release_shared_lock()
   {
      if (lock_type() == LC_LOCK_SHARED)
      {
         THREAD_CHECK(get_db(),"LC_User_ToTest::release_shared_lock()");
         unlock();
      }
   }

   static lc_d_ref<LC_User_ToTest> openref(LC_Database* db, const char* id, int concurrency = -1, int timeout = -1, Db_err* err = 0)
   {
      std::wstring clname_string(__srv_cl_name);
      std::string id_string(id);
      int oref = db->get_proxies_info()->get_oref(__get_class_num(), id_string);
      lc_d_ref<LC_User_ToTest> res = openref(db, oref, __srv_cl_name, id, false, concurrency, timeout, err);
      return res;
   }

   static lc_d_ref<LC_User_ToTest> openref(LC_Database* db, const_name_t id, int concurrency = -1, int timeout = -1, Db_err* err = 0)
   {
      std::wstring clname_string(__srv_cl_name);
      std::wstring id_string(id);
      int oref = db->get_proxies_info()->get_oref(__get_class_num(), id_string);
      lc_d_ref<LC_User_ToTest> res = openref(db, oref, __srv_cl_name, (const char*)id, true, concurrency, timeout, err);
      return res;
   }

   static lc_d_ref<LC_User_ToTest> openref(Database* db, int oref, const_name_t cl_name, const char* ident = 0, bool id_is_uni = false, int concurrency = -1, int timeout = -1, Db_err* err = 0)
   {
      lc_d_ref<LC_User_ToTest> res;
      if (oref)
      {
         Obj_t* obj;
         int* num_refs;
         bool foundref = db->get_proxies_info()->get_lc_proxy_info(oref, &obj, &num_refs);
         if (foundref)
            res = lc_d_ref<LC_User_ToTest>(dynamic_cast<LC_User_ToTest*>(obj), num_refs);
         if (!foundref || (res->concurrency() < LC_LOCK_SHARED && concurrency >= LC_LOCK_SHARED))
         {
            LC_User_ToTest *thisobj = LC_User_ToTest::openid_obj(foundref ? res.operator->() : (LC_User_ToTest *)0, db, oref, (const char *)ident, id_is_uni, false, concurrency, timeout, err);
            if (!thisobj)
            {
               if (foundref)
               {
                  res.make_null();
               }
               else
               {
                  std::wstring cl_name_string(cl_name);
                  if (id_is_uni)
                  {
                     std::wstring ident_string((const_name_t)ident);
                     db->get_proxies_info()->delete_oref(__get_class_num(), ident_string);
                  }
                  else
                  {
                     std::string ident_string(ident);
                     db->get_proxies_info()->delete_oref(__get_class_num(), ident_string);
                  }
               }
            }
            else if (thisobj && !foundref)
            {
               if (thisobj->get_ppclassname().get_size())
               {
                  res = thisobj->reopen_as_subclass(db, (const char *)ident, id_is_uni, concurrency, timeout, err);
                  if (thisobj != res.operator->())
                  {
                     delete thisobj;
                     std::wstring cl_name_string(cl_name);
                     if (id_is_uni)
                     {
                        std::wstring ident_string((const_name_t)ident);
                        db->get_proxies_info()->delete_oref(__get_class_num(), ident_string);
                     }
                     else
                     {
                        std::string ident_string(ident);
                        db->get_proxies_info()->delete_oref(__get_class_num(), ident_string);
                     }
                  }
               }
               else
                  res = lc_d_ref<LC_User_ToTest>(thisobj);
            }
            if (!res.is_null())
            {
               if (id_is_uni)
                  res->set_id((const_name_t)ident);
               else
                  res->set_id(ident);
               res->concurrency(concurrency);
               if (concurrency == LC_CONCURRENCY_NO_LOCKING || concurrency >= LC_CONCURRENCY_SHARED_RETAINED)
                  res->lock_type(concurrency);
               res->has_been_saved(true);
            }
         }
      }
      return res;
   }

   static LC_User_ToTest *openid_obj(LC_User_ToTest *thisobj, Database* db, int oref, const char *ident, bool id_is_uni, bool parse_id, int concurrency, int timeout, Db_err *err)
   {
      lc_dlist_in& in = ((LC_Database *)db)->lc_openid_obj("^User.ToTestD", 12, (const char *)ident, id_is_uni, false, (const char *)0, 0, false, concurrency, timeout, err);
      if (in.isNull())
         return (LC_User_ToTest *) 0;
      if (!thisobj)
         thisobj = new LC_User_ToTest((LC_Database *)db, oref, __srv_cl_name);
      thisobj->getProperties(in);
      if (concurrency == LC_CONCURRENCY_SHARED)
         ((LC_Database*)db)->unlock("^User.ToTestD", 12, (const char *)ident, id_is_uni, LC_LOCK_SHARED, false, true);
      return thisobj;
   }

   static lc_d_ref<LC_User_ToTest> create_new(LC_Database* db, const_str_t init_val = 0, Db_err* err = 0)
   {
      THREAD_CHECK(db,"LC_User_ToTest::create_new()");
      return lc_d_ref<LC_User_ToTest>(new LC_User_ToTest((LC_Database *)db, db->get_proxies_info()->get_next_oref(), (const wchar_t *)LC_User_ToTest::__srv_cl_name));
   }

   static lc_d_ref<LC_User_ToTest> openid(LC_Database* db, const_str_t ident, int concurrency = -1, int timeout = -1, Db_err* err = 0)
   {
      THREAD_CHECK(db,"LC_User_ToTest::openid()");
      if (concurrency < 0)
         concurrency = db->get_default_concurrency_level();
      lc_d_ref<LC_User_ToTest> res = openref(db, ident, concurrency, timeout, err);
      return res;
   }

   static lc_d_ref<LC_User_ToTest> openid(LC_Database* db, const char * ident, int concurrency = -1, int timeout = -1, Db_err* err = 0)
   {
      THREAD_CHECK(db,"LC_User_ToTes::openid()");
      if (concurrency < 0)
         concurrency = db->get_default_concurrency_level();
      lc_d_ref<LC_User_ToTest> res = openref(db, ident, concurrency, timeout, err);
      return res;
   }

   void serialize(lc_dlist_out *outlist, LC_Database *db)
   {
      outlist->append(get_ppclassname(), db);
      
      outlist->append(Test, db);
   }

   void set_from_err_list(const std::pair<d_status, d_binary>& list_entry)
   {
      lc_dlist_in ser;
      ser.setBuf((char *)list_entry.second.get_buf(), list_entry.second.get_size());
      getProperties(ser);
   }

   const unsigned char *get_classname() const { return (const unsigned char *)"User.ToTest"; }
   const wchar_t* get_srv_cl_name() const { return (const wchar_t *)__srv_cl_name; }
   int get_class_num() { return __get_class_num(); }

   int get_classname_length() const { return 11; }

   static d_status direct_save(LC_Database* db, const char* Test, bool defer_indices = false, bool do_transaction = false)
   {
      d_status res;
      THREAD_CHECK(db,"LC_User_ToTest::direct_save()");
      Transaction t(db, do_transaction);
      lc_dlist_out *outlist = db->get_out_list();
      outlist->appendString("",0);
      outlist->appendString(Test, strlen(Test));
      int new_id = db->save_direct("^User.ToTestD", 12, (const char *)"", false, (const char *)0, 0, false, false, -1, -1);
      t.commit();
      return res;
   }

   d_status save(bool defer_indices = false, int timeout = -1, Db_err* err = 0)
   {
      d_status res;
      THREAD_CHECK(get_db(),"LC_User_ToTest::save()");
      if (((LC_Database *)get_db())->in_save())
      {
         int save_num = ((LC_Database *)get_db())->save_number();
         if (save_number() == save_num)
            return res;
         else
            save_number(save_num);
      }
      if (dirty())
      {
         if (!update_allowed())
         {
            LOG_N_THROW_DB_ERR( ERR_CANNOT_UPDATE, "Object of subclass unknown to this application cannot be updated", "save()" );
         }
         LC_Database *db = (LC_Database *)get_db();
         Transaction t(db);
         lc_dlist_out *outlist = db->get_out_list();
         LC_User_ToTest::serialize(outlist, db);
         int concurrency_for_save = concurrency();
         int new_id = db->save("User.ToTest", 11, (const char *)__id, id_is_uni(), has_been_saved(), (lc_dlist_out *)0, concurrency(), timeout, err);
         if (!has_been_saved())
         {
            id(new_id);
            set_oref();
            if (concurrency_for_save >= LC_CONCURRENCY_SHARED_RETAINED)
            {
               lock_type(concurrency_for_save);
            }
         }
         set_clean();
         has_been_saved(true);
         t.commit();
      }
      return res;
   }

   virtual d_status delete_object(bool defer_indices = false, int timeout = -1, Db_err* err = 0)
   {
      d_status res;
      THREAD_CHECK(get_db(),"LC_User_ToTest::delete_object()");
      LC_Database *db = (LC_Database *)get_db();
      Transaction t(db);
      if (!has_been_saved())
      {
         LOG_N_THROW_DB_ERR( ERR_INTERNAL, "Object must be opened or inserted before being deleted", "delete_object()" );
      }
      if (!update_allowed())
      {
         LOG_N_THROW_DB_ERR( ERR_CANNOT_UPDATE, "Object of subclass unknown to this application cannot be deleted", "delete_object()" );
      }
      db->delete_object("User.ToTest", 11, (const char *)__id, id_is_uni(), concurrency(), timeout, err);
      if (concurrency())
      {
         ((LC_Database *)get_db())->unlock_after_delete("^User.ToTestD", 12, (const char *)__id, id_is_uni());
         unlock();
      }
      lock_type(LC_LOCK_NONE);
      set_dirty();
      has_been_saved(false);
      delete_oref();
      clear_id();
      t.commit();
      return res;
   }

   static d_status BuildIndices(LC_Database *db)
   {
      d_status res;
      db->build_indexes((const unsigned char *)"User.ToTest", 11);
      return res;
   }

protected:
   d_int Test;
   virtual void get_old_Test_if_needed(lc_dlist_in&, int& skipnum) { ++skipnum; }
private:

   void getProperties(lc_dlist_in& in)
   {
      set_clean();
      in.get(Test, unicode_srv());
   }

   virtual void unlock()
   {
      ((LC_Database *)get_db())->unlock("^User.ToTestD", 12, (const char *)__id, id_is_uni(), lock_type());
      lock_type(LC_LOCK_NONE);
   }

   lc_d_ref<LC_User_ToTest> reopen_as_subclass(Database *db, const char *ident, bool id_is_uni, int concurrency, int timeout, Db_err *err);

public:

   // Properties

   virtual void setTest(const d_int& val)
   {
      set_dirty(); Test = val;
   }
   virtual d_int getTest() const { return Test; }
};

typedef LC_ClassRegistrar LC_User_ToTest_Registrar;

ISC_NSP_END

#endif

