#include "lc_connection.h"
#include "lc_database.h"
#include "LC_User_ToTest.h"
   
   typedef lc_d_ref<LC_User_ToTest> d_LC_User_ToTest;
   
   int main(int argc, char** argv)
   {
      // establish the physical connection to Cache'
      Db_err conn_err;
      char * str_conn = argv[1];// connection string
      char * str_usr = argv[2]; // username
      char * str_pass = argv[3];// userpassword
      int timeout = 15;
      
      d_connection conn = lc_conn::connect(str_conn,
                                            str_usr, str_pass, timeout, &conn_err);
      if (conn_err)
      {
         std::cerr << conn_err << '\n';
         return -1;
      }
   
      try {
         // establish the logical connection to Cache'
         LC_Database db(conn);

         // create new test
         d_LC_User_ToTest toTest = LC_User_ToTest::create_new(&db, L"", &conn_err);
   
         // assign big number
         toTest->setTest(2147483649); // 2^31 + 1
   
         // Save the object to the database
         toTest->save();
   
         return 0;
      }
      catch(const Db_err& err) {
         std::cerr << err << '\n';
         return -1;
      }
   
      // all objects are closed automatically
   }
